<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_8</title>
</head>
<body>
    <h1>Capitulo 8</h1>
    <a>Ejercicio 14</a>

    <script>
    
        const entreParentesis = (symb, oper, n) => {
            let F = new Array(n);
            let T = new Array(n);
         
            for (let i = 0; i < n; i++) {
                F[i] = new Array(n);
                T[i] = new Array(n);
                for(let j = 0; j < n; j++) {
                    F[i][j] = 0;
                    T[i][j] = 0; 
                }
            }

            for (let i = 0; i < n; i++) {
                F[i][i] = (symb[i] == 'F') 
                    ? 1    
                    : 0;
                T[i][i] = (symb[i] == 'T') 
                    ? 1 
                    : 0;
            }
  
            for (let gap = 1; gap < n; ++gap) {
                for (let i = 0, j = gap; j < n; ++i, ++j) {
                    T[i][j] = F[i][j] = 0;
                    for (let g = 0; g < gap; g++) {
                        let k = i + g;
                        let tik = T[i][k] + F[i][k];
                        let tkj = T[k + 1][j] + F[k + 1][j];

                        if (oper[k] == '&') {
                            T[i][j] += T[i][k] * T[k + 1][j];
                            F[i][j] += (tik * tkj - T[i][k] * T[k + 1][j]);
                        }
                        if (oper[k] == '|') {
                            F[i][j] += F[i][k] * F[k + 1][j];
                            T[i][j] += (tik * tkj - F[i][k] * F[k + 1][j]);
                        }

                        if (oper[k] == '^') {
                            T[i][j] += F[i][k] * T[k + 1][j] + T[i][k] * F[k + 1][j];
                            F[i][j] += T[i][k] * T[k + 1][j] + F[i][k] * F[k + 1][j];
                        }
                 }
                }
            }
            return T[0][n - 1];
        }   
     
        let symbols = "TTFT".split('');
        let operators = "|&^".split('');
        let n = symbols.length;
        console.log(`Numero de parentesis de los simbolos: "true,false,${operators}" son: ${entreParentesis(symbols, operators, n)}`);
        
        
</script>
    
</body>
</html>